/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/

//x[XƂĂvOF
//uTEhvO~Ovؒj
// chapter9 ex9_4.c
//@ADSR

//uTEhvO~OvЂ̃T|[gTCg
// http://floor13.sakura.ne.jp/book06/book06.html
// Achapter09.zip_E[hA𓀂ē
// \chapter09\ex9_4\iir_filter.h
// t@C 
// RX65_SOUND_EFFECTOR_ADSR\src\user\filter\
// ȉɃRs[Ă
// iir_filter.h  "I"i啶ACj́AʂȕϐɒuiႦ"Ix"jɂĂ

//#include "typedefine.h"
#include <machine.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mathf.h>
#include <complex.h>
#include "sound_effector.h"
#include "iir_filter.h"


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

void main(void)
{
	
	int n, m, t0, Ix, J, A, D, R, gate;
	float vco, vcf, vca, gain, S, Q, a[3], b[3];
	
	int spool_data_num;
	unsigned char prev_sw_state;
	
	float *saw_table;											//mRMg̃e[u
	float *saw_table2;											//mRMg̃e[uiLPFKpj
	float *saw_table3;											//mRMg̃e[uiLPFKp, 1j
	
	//֐
	sound_effector_init();
	
	/* mRMg */
	vco = 440.0;	/* {g */
	t0 = PCM_FS / vco;	/* { */
	
	saw_table = calloc(t0 * 3, sizeof(float));
	saw_table2 = calloc(t0 * 3, sizeof(float));
	saw_table3 = calloc(t0, sizeof(float));
	
	if((saw_table == NULL) || (saw_table2 == NULL) || (saw_table3 == NULL))
	{
#ifdef DEBUG
		//ErrLED_
		g_err_led_patturn = LED_BLINK1;
#endif
		while(1);
		//̊mۂɎs
	}
	
	//mRMg̐i3̃e[u쐬j
	m = 0;
	for(n = 0; n < (t0 * 3); n++)
	{
		saw_table[n] = 1.0 - 2.0 * m / t0;
		m++;
		if(m>=t0)
		{
			m=0;
		}
	}
	
	vcf = 1500.0;	/* Ւfg */
	Q = 5.0;		/* ]iX */
	Ix = 2;			/* x̐ */
	J = 2;			/* x̐ */
	
	IIR_LPF(vcf / PCM_FS, Q, a, b);		/* IIRtB^̐݌v */
	
	/* tB^O i3̌MtB^O saw_table2 ɏo */
	for(n = 0; n < (t0 * 3); n++)
	{
		for(m = 0; m <= J; m++)
		{
			if(n - m >= 0)
			{
				saw_table2[n] += b[m] * saw_table[n - m];
			}
		}
		
		for(m = 1; m <= Ix; m++)
		{
			if (n - m >= 0)
			{
				saw_table2[n] += -a[m] * saw_table2[n - m];
			}
		}
	}
	
	/* 3̐M̍Ō̎𔲂o */
	for(n = 0; n < t0; n++)
	{
		saw_table3[n] = saw_table2[n + t0 * 2];
	}
	
	A = 0;							//VR1̒l𔽉fiő1bj
	D = 0;							//VR2̒l𔽉fiő1bj
	S = 0.5;
	R = 0;							//VR3̒l𔽉fiő1bj
	
	gain = 0.5;
	
	gate = 0;						//=OFFiĂȂj
	
	sound_effector_start();			//Jn
	
	g_data_out_flag = DATA_OUT;		//o͊Jn
	
	prev_sw_state = g_sw_state;		//Push-SW̏Ԃۑ
	
	
	while(1)
	{
		if(prev_sw_state != g_sw_state)
		{
			//Push-SWꂽ
			
			if(gate == 0)							//o͒~Ȃ΁AՂꂽƔf
			{
				gate = 1;							//=ONiĂԁj

#ifdef DEBUG
				//ErrLED_
				g_err_led_patturn = LED_ON;
#endif

				A = g_ad_val[0] * PCM_FS / 4096;	//VR1̉]ɉő1b
				D = g_ad_val[1] * PCM_FS / 4096;	//VR2̉]ɉő1b
				
				m=0;
				
				//A
				for (n = 0; n < A; n++)
				{
					vca = 1.0 - exp(-5.0 * n / A);
					
					put_data(clipping_data_norm(saw_table3[m] * vca * gain));
					
					m++;
					if(m >= t0) m = 0;
					
				}
				
				//D
				for (n = 0; n < D; n++)
				{
					vca = S + (1 - S) * exp(-5.0 * n / D);
					
					put_data(clipping_data_norm(saw_table3[m] * vca * gain));
					
					m++;
					if(m >= t0) m = 0;
				}
				
			}
			else if(gate == 1)						//o͒Ȃ΁AՂꂽf
			{
				gate = 0;							//=OFFiĂԁj

#ifdef DEBUG
			//ErrLED
				g_err_led_patturn = LED_OFF;
#endif
				
				R = g_ad_val[2] * PCM_FS / 4096;	//VR3̉]ɉő1b
				
				//R
				for (n = 0; n < R; n++)
				{
					vca = S * exp(-5.0 * (n + 1) / R);
					
					put_data(clipping_data_norm(saw_table3[m] * vca * gain));
					
					m++;
					if(m >= t0) m = 0;
				}
			}
			prev_sw_state = g_sw_state;				//XCb`̏Ԃۑ
		}
		
		if(gate == 1)
		{
			//o͒
			
			//S
			spool_data_num = outbuf_spool_data_num();		//o̓obt@ɗ܂Ăf[^擾
			if(spool_data_num < (int)(PCM_FS * 0.01))		//o̓obt@Ɋi[ς݂̃f[^0.01bƂȂꍇ
			{
				vca = S;
				for(n = 0; n < (int)(PCM_FS * 0.01); n++)	//0.01b̃f[^o̓obt@ɒǉ
				{
					put_data(clipping_data_norm(saw_table3[m] * vca * gain));
					
					m++;
					if(m >= t0) m = 0;
				}
			}
		}
		
		nop();

	}//while
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
